package cn.hanghui.outapi.platform.common.utils;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.util.CollectionUtils;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * @author shisl
 * @package cn.hanghui.outapi.platform.common.utils
 * @class EnumUtils
 * @date 2024/1/18 上午8:59
 * @description
 */
@Slf4j
public class EnumUtils {

    private static final String ENUM_CLASSPATH = "java.lang.Enum";

    public static <T> List<T> enumToListMap(Class<?> enumClass) {
        List<T> resultList = new ArrayList<>();
        if (!ENUM_CLASSPATH.equals(enumClass.getSuperclass().getCanonicalName())) {
            return resultList;
        }
        // 获取所有public方法
        Method[] methods = enumClass.getMethods();
        List<Field> fieldList = new ArrayList<>();
        // step 1:通过get方法提取字段，所以避免get作为自定义方法的开头，建议使用 ‘find’或其他命名
        Arrays.stream(methods).map(Method::getName).filter(
                methodName -> methodName.startsWith("get") && !"getDeclaringClass".equals(methodName) && !"getClass".equals(methodName)
        ).forEachOrdered(methodName -> {
            try {
                Field field = enumClass.getDeclaredField(StringUtils.uncapitalize(methodName.substring(3)));
                fieldList.add(field);
            } catch (NoSuchFieldException | SecurityException e) {
//                log.error(e.getMessage(), e);
            }
        });

        // step 2:将字段作为key，逐一把枚举值作为value 存入list
        if (CollectionUtils.isEmpty(fieldList)) {
            return resultList;
        }

        Enum[] enums = (Enum[]) enumClass.getEnumConstants();
        for (Enum anEnum : enums) {
            Map<Object, Object> map = new HashMap<>(fieldList.size());
            for (Field field : fieldList) {
                field.setAccessible(true);
                try {
                    // 向map集合添加字段名称 和 字段值
                    map.put(field.getName(), field.get(anEnum));
                } catch (IllegalArgumentException | IllegalAccessException e) {
                    log.error(e.getMessage(), e);
                }
            }
            // 将Map添加到集合中
            resultList.add((T) map);
        }
        return resultList;
    }
}
